#declare ConcretePigment = pigment{
     image_map {
        tga "concrete.tga"
        map_type 0	
		interpolate 2	
	}
}   

#declare ConcreteBump = normal{
     bump_map {
        tga "concretebump.tga"
        map_type 0	
		interpolate 2
		bump_size 8	
	}
}

#declare Concrete = texture {
    pigment {ConcretePigment}  
	finish {ambient 0.32 phong 0.2} 
	normal {ConcreteBump}
	scale <2, 1, 1>
}

#declare Concrete1 = texture {
    pigment {ConcretePigment}  
	finish {ambient 0.15 phong 0.2} 
	normal {ConcreteBump}
	scale <2, 1, 1>
} 

#declare BalloonTxt = texture {
    pigment {
        image_map {
            tga "balloon.tga"
            map_type 2	
			interpolate 2	
	    } 
	    scale <1, 2.2, 1>
	}  
	finish {ambient 0.2 phong 0.1}
}

#declare WoodPigment = pigment{
    image_map {
		tga "wood.tga"
		map_type 0	
		interpolate 2	
	}
}

#declare Wood1 = texture {
    pigment  {WoodPigment}
	finish {ambient 0.3 phong 0.3}
    scale<1, 2, 1>
    scale 6
}

#declare StickT = texture {
    pigment {
        image_map {
            tga "cond.tga"
            map_type 0	
			interpolate 2	
	    }
	    rotate z*90
	}  
	finish {ambient 0.3 phong 0.06}
}

#declare Efront = texture { 
    pigment {
        image_map {
            tga "electric.tga"
            map_type 0	
		    interpolate 2	
	    } 
	}  
	finish {ambient 0.3 phong 0.4}
} 

#declare Eside = texture { 
    pigment {
        image_map {
            tga "eside.tga"
            map_type 0	
		    interpolate 2	
	    } 
	}  
	finish {ambient 0.3 phong 0.4}
}

#declare TorTxt = texture {
    pigment {
        image_map {
            tga "balloon.tga"
            map_type 3	
            interpolate 2	
	    } 
	    scale <1, 2.5, 1>
	    rotate -z*90
	}  
	finish {ambient 0.3 phong 0.1}
}

#declare WiresTxt = texture{  
    pigment { rgb 1}
	finish {ambient 0.18 phong 1 phong_size 80}
}

#declare CondPigment = pigment {
    image_map {
        tga "cond.tga"
        map_type 0	
	    interpolate 2	
	}
}

#declare TubeTexture = texture {
    pigment {CondPigment rotate z*90}  
	finish {ambient 0.2 phong 0.06}
	scale <0.2, 1.6, 1>
	translate -y*0.9
}

#declare RustTxt = texture {
    pigment  {
	    image_map {
	        tga "rust.tga"
		    map_type 0	
		    interpolate 2	
		}
	}  
    finish {ambient 0.12 phong 0.04}  
    scale <1, 4, 1>
    rotate y*45
}

#declare Wood = texture {
    pigment  {WoodPigment}
	finish {ambient 0.2 phong 0.15}
	normal {
	    bump_map {
	    tga "woodbump.tga"
	    map_type 0	
		interpolate 2
		bump_size -4	
		}
	}
    scale<1, 2, 1>
    scale 6
}  

#declare DoorTxt = texture { 
    pigment  {
	    image_map {
            tga "door.tga"
			map_type 0	
			interpolate 2	
		}
	}  
	finish {ambient 0.2 phong 0.04}
	scale<2.2, 1, 1>
	scale 12
	translate -x*1
} 

#declare WallTxt = texture { 
    pigment  {
		image_map {
		   tga "wall.tga"
		   once
		   map_type 0	
		   interpolate 2	
		}
	}  
	finish {ambient 0.2 phong 0}
}  

#declare FloorTxt = texture { 
	pigment  {
	    image_map {
	       tga "floor.tga"
		   map_type 0	
		   interpolate 2	
		}
	} 
	normal {
	    bump_map {
	    tga "floorbump.tga"
	    map_type 0	
		interpolate 2
		bump_size 5	
		}
	} 
	finish {ambient 0.16 phong 0.2} 
	scale 12
}

#declare BoardTxt = texture { 
	pigment  {WoodPigment}
    finish {ambient 0.12 phong 0.1}
    scale<1, 2, 1>
    scale 6
    rotate z*90 
    translate -y*0.2
}

#declare HydroTxt = texture {
    pigment {
        image_map {
            tga "balloon.tga"
            map_type 0	
	        interpolate 2	
	    } 
	    scale <1, 2.2, 1>
	    scale 2
	}  
	finish {ambient 0.15 phong 0.1}
}

#declare CondTxt = texture {
    pigment {
        CondPigment 
	    scale <6, 1.5, 1>
	    translate -x*3
	}  
	finish {ambient 0.16 phong 0.1}
}       

#declare GreenRustTxt = texture { 
	pigment  {
	    image_map {
	       tga "green.tga"
		   map_type 0	
		   interpolate 2	
		} 
		scale<2, 1, 1>
	}  
	finish {ambient 0.15 phong 0.1} 
} 

#declare SpiralTxt = texture{
    pigment{color rgb <0.82, 0.86, 0.9>}
    finish{ambient 0.1 phong 1 phong_size 30 metallic reflection 0.2}
}  

#declare Blue1RustTxt = texture { 
	pigment  {
	    image_map {
	       tga "blue1.tga"
		   map_type 1	
		   interpolate 2	
		} 
	}  
	finish {ambient 0.15 phong 0.1} 
} 

#declare Blue2RustTxt = texture { 
	pigment  {
	    image_map {
	       tga "blue2.tga"
		   map_type 0	
		   interpolate 2	
		} 
		scale<1.5, 1, 1>
	}  
	finish {ambient 0.15 phong 0.1} 
}

#declare BoxTxt = texture {
    pigment {
        image_map {
            tga "box.tga"
            map_type 0	
	        interpolate 2	
	    } 
	    scale <1, 1.1, 1>
	}  
	finish {ambient 0.15 phong 0.1}
}